function g = grad01(fun,beta,x,param) ;
% Computes the grad of 'fun' with respect to 'beta'.
% x is an optional input containing other arguments of fun
% param is a structure that allows one to change delta, the stepsize
% Usage:  g = grad01(fun,beta,x,param) ;
%
% Last edited:  Nov 26, 2004
%
if nargin < 4 ;
	param = '' ;
end ;

if isfield(param,'delta') == 0 ;
	delta = 10e-5 ;
else ;
	delta = param.delta ;   
end ;

m = size(beta,1) ;
if m== 1 ; 
    beta = beta' ; 
end ;
m = size(beta,1) ;

ii = eye(m) ;
fbase = eval(fun) ;
betaold = beta ;
n = size(fbase,1) ;

g=zeros(n,m) ;
for i = 1:m ;
beta = betaold + delta * ii(:,i) ;
f1 = eval(fun) ;
beta = betaold - delta * ii(:,i) ;
f2 = eval(fun) ;
g(:,i) = (f1-f2) / (2*delta) ;
end ;

