function y = hessian01(fun,beta,x,param) ;
%  Returns the hessian of fun
%  Usage: y = hessian01(fun,beta,x,del) ;
%
if nargin < 4 ;
	param = '' ;
end ;

if isfield(param,'delta') == 0 ;
	delta = 10e-5 ;
else ;
	delta = param.delta ;   
end ;

m = size(beta,1) ;
ey = eye(m) ;
betaold = beta ;
f5 = zeros(m,m) ;
for i = 1:m ;
    for j = 1:m ;
        if j < i+1 ;
            beta = betaold + delta*(ey(:,i)+ey(:,j))/2 ;
            f1 = sum(eval(fun)) ;
            
            beta = betaold + delta*(ey(:,i)-ey(:,j))/2 ;
            f2 = sum(eval(fun)) ;
            
            beta = betaold + delta*(-ey(:,i)+ey(:,j))/2 ;
            f3 = sum(eval(fun)) ;
            
            beta = betaold + delta*(-ey(:,i)-ey(:,j))/2 ;
            f4 = sum(eval(fun)) ;
            
            f5(i,j) = f1 - f2 - f3 + f4 ;
        else;
            f5(j,i) = f5(i,j) ; 
        end ;
    end ;
end ;
y = f5 / (delta*delta) ;
