function hub = huber(x,k);
% 
% Computes the Huber psi and rho functions of x with cutoffs -k and +k
%
md = mad(x) ./ norminv(.75) ;
k = k*md ;
i1 = (x<-k) ;
i2 = (x>k) ;
psi = -k.*i1 + k.*i2 + x.*(1-i1-i2) ;
rho = (i1+i2).*(2*k*abs(x) -k^2) + (1-i1-i2).* x.^2 ;
hub = struct('psi',psi,'rho',rho) ;