function L = relike01(sigma2,D,X,Z,y) ;
% computes the restricted likelihood assuming that the covariance of y is (sigma^2)*I
sigma2e = sigma2(1) ;
D = sigma2(2)*D ;

[n,p] = size(X) ;
[n,q] = size(Z) ;
XX = [X'*X X'*Z ; Z'*X Z'*Z + sigma2*inv(D)] ;
pls = inv(XX)*[X Z]'*y ;
betahat = pls(1:p) ;
uhat = pls(p+1:p+q) ;
logdetV = log(det(eye(q) + Z'*Z*D/sigma2)) + n*log(sigma2) ;
invV = (eye(n) - Z*D*inv(eye(q) + Z'*Z*D)*Z') / sigma2 ;
logdetXIVX = log(det(X'*invV*X)) ;
resid = y-X*betahat ;
L = .5* (logdetV + logdetXIVX + resid'*invV*resid ) ;
% output = struct('L',L,'uhat',uhat,'betahat',betahat) ;